Package org.apache.tomcat.websocket

## Class Authenticator

- java.lang.Object
- - org.apache.tomcat.websocket.Authenticator

Direct Known Subclasses:
  `BasicAuthenticator`, `DigestAuthenticator`

    public abstract class Authenticator
    extends Object

Base class for the authentication methods used by the websocket client.

### Constructor Summary

Constructors
`Authenticator()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract String` `getAuthorization​(String requestUri, String WWWAuthenticate, Map<String,​Object> UserProperties)` Generate the authentication header that will be sent to the server.
`abstract String` `getSchemeName()` Get the authentication method.
`Map<String,​String>` `parseWWWAuthenticateHeader​(String WWWAuthenticate)` Utility method to parse the authentication header.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Authenticator

    public Authenticator()

### Method Detail

#### getAuthorization

    public abstract String getAuthorization​(String requestUri,
                                            String WWWAuthenticate,
                                            Map<String,​Object> UserProperties)
                                     throws AuthenticationException

Generate the authentication header that will be sent to the server.

Parameters:
  `requestUri` - The request URI
  `WWWAuthenticate` - The server auth challenge
  `UserProperties` - The user information
Returns:
  The auth header
Throws:
  `AuthenticationException` - When an error occurs

#### getSchemeName

    public abstract String getSchemeName()

Get the authentication method.

Returns:
  the auth scheme

#### parseWWWAuthenticateHeader

    public Map<String,​String> parseWWWAuthenticateHeader​(String WWWAuthenticate)

Utility method to parse the authentication header.

Parameters:
  `WWWAuthenticate` - The server auth challenge
Returns:
  the parsed header